function [dec_k, dec_c, dec_stock, dec_l_hat, dec_phihat] = get_decision_functions(this_PSTAR,...
    num_eval_out_stage1, order, eta_stage1, eta_stage2, CSTAR_initial_guess, LSTAR_initial_guess,...
    DELTA, ALFA, BETTA, G, ETA, GAMA, SIGM, LAMBDAP, MU, ZSTAR, PHISTAR, sym_labor_supply, intertemporal_euler_ss,...
    LAMBDAZ, sigma_Z, PSISTARS, n_Psis, LAMBDAPsi, u, decision_func_to_use)


P = this_PSTAR;
Pp = this_PSTAR;
flatten = @(A) A(:);
approx = order;

[KSTAR, CSTAR, LSTAR, WSTAR, RSTAR] = model2_ss_numeric(1, CSTAR_initial_guess, LSTAR_initial_guess, DELTA, ALFA, BETTA, G, P, ETA, GAMA, SIGM, ZSTAR, PHISTAR, sym_labor_supply, intertemporal_euler_ss);

k=KSTAR; c=CSTAR; l=LSTAR;
kp=KSTAR; cp=CSTAR; lp=LSTAR;
stockSTAR = G*((P-1)/P)*y_func(KSTAR,LSTAR,ZSTAR,ALFA,PHISTAR)/((1+RSTAR) - G); stock = stockSTAR; stockp = stockSTAR;
lhat = LSTAR; lhatp = LSTAR;
Z = ZSTAR; Z1 = ZSTAR; Z2 = ZSTAR; Z3 = ZSTAR; Zp = ZSTAR; Z1p = ZSTAR; Z2p = ZSTAR; Z3p = ZSTAR;
phihat = PHISTAR; phihatp = PHISTAR;

for var = ["Psi_tminus1", "Psi_tminus1p", "Psi", "Psip"]
    for i = 1:n_Psis
        eval(sprintf('%s%d=PSISTARS(%d);',var,i,i))
    end
end

for i = 1:n_Psis
   eval(sprintf('%s%d=LAMBDAPsi(%d);',"LAMBDAPsi",i,i))
end



if ~isequal(functions(num_eval_out_stage1).function(1:25), '@(CSTAR,KSTAR,LSTAR,P,Pp)')
    warning('num_eval_out_stage1 only works if it is a function of CSTAR, KSTAR, LSTAR, P, and Pp, in that order. Instead it is asking for %s',...
        functions(num_eval_out_stage1).function(1:25))
end
[nfx, nfxp, nfy, nfyp, nfypyp, nfypy, nfypxp, nfypx, nfyyp, nfyy, nfyxp, nfyx, nfxpyp, nfxpy, nfxpxp, nfxpx, nfxyp, nfxy, nfxxp, nfxx] = num_eval_out_stage1(CSTAR, KSTAR, LSTAR, P, Pp);

%First-order approximation
[gx,hx] = gx_hx(nfy, nfx, nfyp, nfxp);

[nstate,~] = size(hx);

if order >= 2
    %Second-order approximation
    [gxx,hxx] = gxx_hxx(nfx,nfxp,nfy,nfyp,nfypyp,nfypy,nfypxp,nfypx,nfyyp,nfyy,nfyxp,nfyx,nfxpyp,nfxpy,nfxpxp,nfxpx,nfxyp,nfxy,nfxxp,nfxx,hx,gx);

    [gss,hss] = gss_hss(nfx,nfxp,nfy,nfyp,nfypyp,nfypy,nfypxp,nfypx,nfyyp,nfyy,nfyxp,nfyx,nfxpyp,nfxpy,nfxpxp,nfxpx,nfxyp,nfxy,nfxxp,nfxx,hx,gx,gxx,eta_stage1);

    dec_l_hat = [LSTAR,gx(1,:),1/2*flatten(gxx(1,:,:))',1/2*gss(1)];
    dec_phihat = [PHISTAR,gx(3,:),1/2*flatten(gxx(3,:,:))',1/2*gss(3)];

else
    dec_l_hat = [LSTAR,gx(1,:),zeros([1 nstate^2+1])];
    dec_phihat = [PHISTAR,gx(3,:),zeros([1 nstate^2+1])];

end



ssvals_stage1 = [KSTAR,ZSTAR,ZSTAR,ZSTAR,ZSTAR,this_PSTAR,PSISTARS];


[fx,fxp,fy,fyp,fypyp,fypy,fypxp,fypx,fyyp,fyy,fyxp,fyx,fxpyp,fxpy,fxpxp,fxpx,fxyp,fxy,fxxp,fxx,f] = stage2model(u, n_Psis, dec_l_hat, dec_phihat, decision_func_to_use, ssvals_stage1);

%Obtain numerical derivatives of f
num_eval

%First-order approximation
[gx,hx] = gx_hx(nfy,nfx,nfyp,nfxp);

[nstate,~] = size(hx);

if order >= 2
    %Second-order approximation
    [gxx,hxx] = gxx_hxx(nfx,nfxp,nfy,nfyp,nfypyp,nfypy,nfypxp,nfypx,nfyyp,nfyy,nfyxp,nfyx,nfxpyp,nfxpy,nfxpxp,nfxpx,nfxyp,nfxy,nfxxp,nfxx,hx,gx);

    [gss,hss] = gss_hss(nfx,nfxp,nfy,nfyp,nfypyp,nfypy,nfypxp,nfypx,nfyyp,nfyy,nfyxp,nfyx,nfxpyp,nfxpy,nfxpxp,nfxpx,nfxyp,nfxy,nfxxp,nfxx,hx,gx,gxx,eta_stage2);

    dec_k=[KSTAR,hx(1,:),1/2*flatten(hxx(1,:,:))',1/2*hss(1)];
    dec_c=[CSTAR,gx(1,:),1/2*flatten(gxx(1,:,:))',1/2*gss(1)];
    dec_stock = [stockSTAR,gx(2,:),1/2*flatten(gxx(2,:,:))',1/2*gss(2)];

else
    dec_k=[KSTAR,hx(1,:),zeros([1 nstate^2+1])]; 
    dec_c=[CSTAR,gx(1,:),zeros([1 nstate^2+1])];
    dec_stock = [stockSTAR,gx(2,:),zeros([1 nstate^2+1])];

end
