%This program evaluates the analytical first and second (if approx=2) derivatives of f numerically. The parameters and steady state values of the arguments of the function f are assumed to be in the workspace. Also, the order of approximation must be in the workspace.
%
%(c) Stephanie Schmitt-Grohe and Martin Uribe
%Date July 17, 2001
%Changed on September 25, 2001 to replace subs with eval and make it no longer a function.

k=KSTAR; c=CSTAR; l=LSTAR; lhat = LSTAR;
kp=KSTAR; cp=CSTAR; lp=LSTAR; lhatp = LSTAR;
stockSTAR = G*((P-1)/P)*y_func(KSTAR,LSTAR,ZSTAR,ALFA,PHISTAR)/((1+RSTAR) - G);
stock = stockSTAR; stockp = stockSTAR;

sfx = sym(zeros(size(fx)));
sfx(:) = eval(fx(:));

sfxp = sym(zeros(size(fxp)));
sfxp(:)= eval(fxp(:));

sfy = sym(zeros(size(fy)));
sfy(:) = eval(fy(:));

sfyp = sym(zeros(size(fyp)));
sfyp(:)= eval(fyp(:));

sf = sym(zeros(size(f)));
sf(:)=eval(f(:));

if approx==1
   
%If only a first-order approximation is desired, set all second derivatives equal to zero
sfypyp=0; sfypy=0; sfypxp=0; sfypx=0; sfyyp=0; sfyy=0; sfyxp=0; sfyx=0; sfxpyp=0; sfxpy=0; sfxpxp=0; sfxpx=0; sfxyp=0; sfxy=0; sfxxp=0; sfxx=0;
   
else

sfypyp=sym(zeros(size(fypyp)));
sfypyp(:)=eval(fypyp(:));

sfypy=sym(zeros(size(fypy)));
sfypy(:)=eval(fypy(:));

sfypxp=sym(zeros(size(fypxp)));
sfypxp(:)=eval(fypxp(:));

sfypx=sym(zeros(size(fypx)));
sfypx(:)=eval(fypx(:));

sfyyp=sym(zeros(size(fyyp)));
sfyyp(:)=eval(fyyp(:));

sfyy=sym(zeros(size(fyy)));
sfyy(:)=eval(fyy(:));

sfyxp=sym(zeros(size(fyxp)));
sfyxp(:)=eval(fyxp(:));

sfyx=sym(zeros(size(fyx)));
sfyx(:)=eval(fyx(:));

sfxpyp=sym(zeros(size(fxpyp)));
sfxpyp(:)=eval(fxpyp(:));

sfxpy=sym(zeros(size(fxpy)));
sfxpy(:)=eval(fxpy(:));

sfxpxp=sym(zeros(size(fxpxp)));
sfxpxp(:)=eval(fxpxp(:));

sfxpx=sym(zeros(size(fxpx)));
sfxpx(:)=eval(fxpx(:));

sfxyp=sym(zeros(size(fxyp)));
sfxyp(:)=eval(fxyp(:));

sfxy=sym(zeros(size(fxy)));
sfxy(:)=eval(fxy(:));

sfxxp=sym(zeros(size(fxxp)));
sfxxp(:)=eval(fxxp(:));

sfxx=sym(zeros(size(fxx)));
sfxx(:)=eval(fxx(:));

end